Package groovy.xml.slurpersupport

# Class Attributes

java.lang.Object
groovy.lang.GroovyObjectSupport
groovy.xml.slurpersupport.GPathResult
groovy.xml.slurpersupport.NodeChildren
groovy.xml.slurpersupport.Attributes

All Implemented Interfaces:
  `Buildable`, `GroovyObject`, `Writable`, `Iterable`

Direct Known Subclasses:
  `FilteredAttributes`

public class Attributes extends NodeChildren
Lazy evaluated representation of a node's attributes.

- ## Field Summary

  ### Fields inherited from class groovy.xml.slurpersupport.GPathResult

  `name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Attributes(GPathResult parent, String name, String namespacePrefix, Map<String,String> namespaceTagHints)`
  `Attributes(GPathResult parent, String name, Map<String,String> namespaceTagHints)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `build(GroovyObject builder)`
  `Iterator`
  `childNodes()`
  Throws a `GroovyRuntimeException`, because attributes can have no children.
  `GPathResult`
  `findAll(Closure closure)`
  Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
  `Iterator`
  `iterator()`
  `List`
  `list()`
  Creates a list of objects representing this GPathResult.
  `String`
  `name()`
  Returns the name of this GPathResult.
  `Iterator`
  `nodeIterator()`
  `GPathResult`
  `parents()`
  Throws a `GroovyRuntimeException`, because it is not implemented yet.
  `String`
  `text()`
  Returns the text of this GPathResult as a `String`.
  `Writer`
  `writeTo(Writer out)`
  Writes this object to the given writer.

  ### Methods inherited from class groovy.xml.slurpersupport.NodeChildren

  `appendNode, find, replaceBody, replaceNode, size`

  ### Methods inherited from class groovy.xml.slurpersupport.GPathResult

  `breadthFirst, children, createIterator, declareNamespace, depthFirst, equals, getAt, getAt, getBody, getProperty, hashCode, isEmpty, leftShift, lookupNamespace, parent, plus, plus, pop, putAt, setMetaClass, setProperty, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`

  ### Methods inherited from class groovy.lang.GroovyObjectSupport

  `getMetaClass`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface groovy.lang.GroovyObject

  `invokeMethod`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### Attributes

    public Attributes(GPathResult parent, String name, String namespacePrefix, Map<String,String> namespaceTagHints)
    Parameters:
      `parent` - the GPathResult prior to the application of the expression creating this GPathResult
      `name` - if the GPathResult corresponds to something with a name, e.g. a node
      `namespacePrefix` - the namespace prefix if any
      `namespaceTagHints` - the known tag to namespace mappings

  - ### Attributes

    public Attributes(GPathResult parent, String name, Map<String,String> namespaceTagHints)
    Parameters:
      `parent` - the GPathResult prior to the application of the expression creating this GPathResult
      `name` - if the GPathResult corresponds to something with a name, e.g. a node
      `namespaceTagHints` - the known tag to namespace mappings

- ## Method Details

  - ### name

    public String name()
    Description copied from class: `GPathResult`
    Returns the name of this GPathResult.
    Overrides:
      `name` in class `GPathResult`
    Returns:
      the name of this GPathResult

  - ### childNodes

    public Iterator childNodes()
    Throws a `GroovyRuntimeException`, because attributes can have no children.
    Overrides:
      `childNodes` in class `NodeChildren`
    Returns:
      an iterator over the child nodes of this GPathResult

  - ### iterator

    public Iterator iterator()
    Specified by:
      `iterator` in interface `Iterable`
    Overrides:
      `iterator` in class `NodeChildren`

  - ### nodeIterator

    public Iterator nodeIterator()
    Overrides:
      `nodeIterator` in class `NodeChildren`

  - ### parents

    public GPathResult parents()
    Description copied from class: `NodeChildren`
    Throws a `GroovyRuntimeException`, because it is not implemented yet.
    Overrides:
      `parents` in class `NodeChildren`
    Returns:
      the parents of this GPathResult

  - ### text

    public String text()
    Description copied from class: `GPathResult`
    Returns the text of this GPathResult as a `String`.
    Overrides:
      `text` in class `NodeChildren`
    Returns:
      the text of this GPathResult

  - ### list

    public List list()
    Description copied from class: `GPathResult`
    Creates a list of objects representing this GPathResult.
    Overrides:
      `list` in class `GPathResult`
    Returns:
      a list representing of this GPathResult

  - ### findAll

    public GPathResult findAll(Closure closure)
    Description copied from class: `GPathResult`
    Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
    Overrides:
      `findAll` in class `NodeChildren`
    Parameters:
      `closure` - a closure to filters the children of this GPathResult
    Returns:
      the children matching the closure

  - ### writeTo

    public Writer writeTo(Writer out) throws IOException
    Description copied from interface: `Writable`
    Writes this object to the given writer.

    This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as it may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

    Specified by:
      `writeTo` in interface `Writable`
    Overrides:
      `writeTo` in class `NodeChildren`
    Parameters:
      `out` - the Writer to which this Writable should output its data.
    Returns:
      the Writer that was passed
    Throws:
      `IOException` - if an error occurred while outputting data to the writer

  - ### build

    public void build(GroovyObject builder)
    Specified by:
      `build` in interface `Buildable`
    Overrides:
      `build` in class `NodeChildren`